install-nix-action/install-nix.sh

95 lines
2.8 KiB
Bash
Raw Normal View History

2020-02-26 13:12:17 +00:00
#!/usr/bin/env bash
set -euo pipefail
2023-03-08 21:24:48 +00:00
if nix_path="$(type -p nix)" ; then
echo "Aborting: Nix is already installed at ${nix_path}"
exit
fi
# GitHub command to put the following log messages into a group which is collapsed by default
echo "::group::Installing Nix"
# Create a temporary workdir
workdir=$(mktemp -d)
trap 'rm -rf "$workdir"' EXIT
2020-08-25 16:26:01 +00:00
# Configure Nix
add_config() {
echo "$1" >> "$workdir/nix.conf"
2020-08-25 16:26:01 +00:00
}
2020-05-26 12:34:45 +00:00
# Set jobs to number of cores
2020-08-25 16:26:01 +00:00
add_config "max-jobs = auto"
2023-06-16 18:51:34 +00:00
if [[ $OSTYPE =~ darwin ]]; then
add_config "ssl-cert-file = /etc/ssl/cert.pem"
fi
# Allow binary caches for user
2023-03-01 05:48:32 +00:00
add_config "trusted-users = root ${USER:-}"
# Add github access token
if [[ -n "${INPUT_GITHUB_ACCESS_TOKEN:-}" ]]; then
add_config "access-tokens = github.com=$INPUT_GITHUB_ACCESS_TOKEN"
elif [[ -n "${GITHUB_TOKEN:-}" ]]; then
add_config "access-tokens = github.com=$GITHUB_TOKEN"
fi
2020-08-25 16:13:35 +00:00
# Append extra nix configuration if provided
if [[ -n "${INPUT_EXTRA_NIX_CONFIG:-}" ]]; then
2020-08-25 16:26:01 +00:00
add_config "$INPUT_EXTRA_NIX_CONFIG"
fi
if [[ ! $INPUT_EXTRA_NIX_CONFIG =~ "experimental-features" ]]; then
add_config "experimental-features = nix-command flakes"
fi
2020-08-25 16:26:01 +00:00
# Nix installer flags
installer_options=(
--no-channel-add
--darwin-use-unencrypted-nix-store-volume
--nix-extra-conf-file "$workdir/nix.conf"
)
# only use the nix-daemon settings if on darwin (which get ignored) or systemd is supported
if [[ (! $INPUT_INSTALL_OPTIONS =~ "--no-daemon") && ($OSTYPE =~ darwin || -e /run/systemd/system) ]]; then
installer_options+=(
--daemon
2022-08-05 08:35:03 +00:00
--daemon-user-count "$(python3 -c 'import multiprocessing as mp; print(mp.cpu_count() * 2)')"
)
else
# "fix" the following error when running nix*
# error: the group 'nixbld' specified in 'build-users-group' does not exist
add_config "build-users-group ="
sudo mkdir -p /etc/nix
sudo chmod 0755 /etc/nix
sudo cp "$workdir/nix.conf" /etc/nix/nix.conf
fi
if [[ -n "${INPUT_INSTALL_OPTIONS:-}" ]]; then
2021-11-17 22:02:06 +00:00
IFS=' ' read -r -a extra_installer_options <<< "$INPUT_INSTALL_OPTIONS"
2021-02-21 14:00:04 +00:00
installer_options=("${extra_installer_options[@]}" "${installer_options[@]}")
2021-02-20 21:46:57 +00:00
fi
2020-02-26 13:12:17 +00:00
2021-11-17 22:02:06 +00:00
echo "installer options: ${installer_options[*]}"
2021-11-01 18:04:45 +00:00
# There is --retry-on-errors, but only newer curl versions support that
curl_retries=5
2023-06-16 18:51:56 +00:00
while ! curl -sS -o "$workdir/install" -v --fail -L "${INPUT_INSTALL_URL:-https://releases.nixos.org/nix/nix-2.16.1/install}"
2021-11-01 18:04:45 +00:00
do
sleep 1
((curl_retries--))
if [[ $curl_retries -le 0 ]]; then
echo "curl retries failed" >&2
exit 1
fi
2021-11-01 18:04:45 +00:00
done
sh "$workdir/install" "${installer_options[@]}"
2020-05-27 11:17:01 +00:00
2020-02-26 13:12:17 +00:00
# Set paths
echo "/nix/var/nix/profiles/default/bin" >> "$GITHUB_PATH"
2023-03-01 05:29:17 +00:00
# new path for nix 2.14
echo "$HOME/.nix-profile/bin" >> "$GITHUB_PATH"
2020-05-28 14:25:05 +00:00
if [[ -n "${INPUT_NIX_PATH:-}" ]]; then
echo "NIX_PATH=${INPUT_NIX_PATH}" >> "$GITHUB_ENV"
2020-05-28 14:25:05 +00:00
fi
# Close the log message group which was opened above
echo "::endgroup::"